#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Utils include files                                            */
#include "../../../src/file_util.h"
#include "../../../src/mq_util.h"
#include "../../../src/str_util.h"

#include "profile.h"

PINITFILE ReadProfile(char *FileName)
{
   FILE *fp = NULL;
   char buffer[256];
   PINITFILE InitFile = NULL;																	/* 19/08/2001 */

   if ( (fp = fopen(FileName, "r")) == NULL ) {
      fprintf(stderr, "Cannot open profile : %s!\n", FileName);
      return(NULL);
   }

   if ( (InitFile = (PINITFILE)malloc(sizeof(INITFILE))) == NULL) {
      fprintf(stderr, "Cannot allocate memory !\n");
      return(NULL);
   }

   *(InitFile->qmgr)       = '\0';
   *(InitFile->logdir)     = '\0';
   *(InitFile->replyq)     = '\0';
   memcpy(InitFile->dismqsie, "YES", YESNOLEN);
   memcpy(InitFile->logmqsie, "YES", YESNOLEN);

	InitFile->loglevel      = MQLogLevel = 2;
   
   while ( fgets(buffer, sizeof(buffer) - 1, fp) ) {
      buffer[strlen(buffer) - 1] = '\0';

      if ( strncmp(buffer, "logdir=", 7) == 0 ) {
         strcpy(InitFile->logdir, buffer + 7);
         CheckPath(InitFile->logdir);
      }
      else if ( strncmp(buffer, "qmgr=", 5) == 0 )
         strcpy(InitFile->qmgr, buffer + 5);
      else if ( strncmp(buffer, "replyq=", 7) == 0 )
         strcpy(InitFile->replyq, buffer + 7);
      else if ( strncmp(buffer, "dismqsie=", 9) == 0 ) {
         strcpy(InitFile->dismqsie, buffer + 9);
         StrUpper(InitFile->dismqsie);
      }
      else if ( strncmp(buffer, "logmqsie=", 9) == 0 ) {
         strcpy(InitFile->logmqsie, buffer + 9);
         StrUpper(InitFile->logmqsie);
      }
	   else if ( strncmp(buffer, "loglevel=", 9) == 0 ) {
         InitFile->loglevel = atoi(buffer + 9);
		   MQLogLevel = InitFile->loglevel;
	   }
   }

   MQLogLevel = InitFile->loglevel;
	
	if (fclose(fp) == EOF) {
     fprintf(stderr, "Cannot close profile : %s!\n", FileName);
     return(NULL);
	}

	return(InitFile);
}


int LogInitFile(PINITFILE InitFile, char *Title)
{
   int rc = 0;
   static char LogText[255];

   sprintf(LogText,  "Start %s for QMgr %.48s" 
	                  "\n\t\t\treplyq = %.48s" 
					      "\n\t\t\tloglevel = %d" 
                     "\n\t\t\tdismqsie = %.*s" 
                     "\n\t\t\tlogmqsie = %.*s",
         Title,
		   ( (*(InitFile->qmgr) == '\0') ? "<default>" : InitFile->qmgr),
	      InitFile->replyq,
		   InitFile->loglevel,
         YESNOLEN, InitFile->dismqsie,
         YESNOLEN, InitFile->logmqsie );
      
   rc = WriteLogFile(InitFile->logdir, LOG, LogText);

   return(rc);
}
