#ifndef _H_EXPEDITE
#define _H_EXPEDITE

#include <cmqc.h>

#include "../../../src/file_util.h"
#include "../../../src/str_util.h"

#include "profile.h"

#ifdef OS400
#define BASEIN    "INMSG"
#define BASEOUT   "OUTMSG"
#else
#define BASEIN    "basein.msg"
#define BASEOUT   "baseout.msg"
#endif

#define MAXFILEIDLEN   128
#define LENGTHLEN        9

#define SYSIDLEN         3
#define ACCOUNTLEN       8
#define USERIDLEN        8
#define LISTNAMELEN      8
#define CLASSLEN         8

typedef struct tagIESENDINFO{
   /* Information Exchange address        */
   char SysId[SYSIDLEN+1];
   char Account[ACCOUNTLEN+1];
   char UserId[USERIDLEN+1];
   /* File to send info                   */
   char FileId[MAXFILEIDLEN+1];
   long FileSize;
   char Length[LENGTHLEN];  
   /* CLASS                               */
   char Class[CLASSLEN];  
   /* MQSeries information                */
   char DestinationQ[MQ_Q_NAME_LENGTH];
   char ReplyToQ[MQ_Q_NAME_LENGTH];
} IESENDINFO;

typedef IESENDINFO * PIESENDINFO;

typedef struct tagIERECVINFO {
   /* Information Exchange address        */
   char SysId[SYSIDLEN+1];
   char Account[ACCOUNTLEN+1];
   char UserId[USERIDLEN+1];
   /* CLASS                               */
   char Class[CLASSLEN];  
   /* File to send info                   */
   char FileId[MAXFILEIDLEN+1];
   /* MQSeries information                */
   char ReplyToQ[MQ_Q_NAME_LENGTH+1];
} IERECVINFO;

typedef IERECVINFO * PIERECVINFO;

PIESENDINFO GetSendInfo(PIESENDINFO SendInfo, char *buffer, long bufferlength);
PIERECVINFO GetRecvInfo(PIERECVINFO RecvInfo, char *buffer, long bufferlength);

int ReceiveFile(char *LogDir, MQHCONN Hconn, MQCHAR48 QName, MQLONG BufferLength, char *FileName, MQBYTE24 MsgId, MQBYTE24 CorrelId);
int SendFile(char *LogDir, MQHCONN Hconn, MQCHAR48 QName, MQCHAR48 QMgrName, MQCHAR48 ReplyToQ, MQCHAR48 ReplyToQMgr, MQCHAR8 Format, char *FileName, PMQBYTE Header, MQLONG HeaderLength, PMQBYTE Trailer, MQLONG TrailerLength);

int GetExpediteBaseFiles(PINITFILE InitFile, char *BaseInFileName, FILE **pBaseIn, char *BaseOutFileName, FILE **pBaseOut);

#endif
