#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/* Utils include files                                            */
#include "../../../src/defs.h"        /* general include file     */
#include "../../../src/file_util.h"   /* file functions           */
#include "../../../src/mq_util.h"     /* MQSeries functions       */
/* Functions specific include file                                */
#include "profile.h"

PINITFILE ReadProfile(char *FileName)
{
   FILE *fp = NULL;
   char buffer[256];
   PINITFILE InitFile = NULL;

   if ( (fp = fopen(FileName, "r")) == NULL ) {
      fprintf(stderr, "Cannot open profile : %s!\n", FileName);
      return(NULL);
   }

   if ( (InitFile = (PINITFILE)malloc(sizeof(INITFILE))) == NULL) {
      fprintf(stderr, "Cannot allocate memory !\n");
      return(NULL);
   }

   *(InitFile->qmgr)       = '\0';
   *(InitFile->logdir)     = '\0';
   *(InitFile->replyq)     = '\0';
   *(InitFile->replyqmgr)  = '\0';															/* 22/05/2001 */
	InitFile->loglevel      = MQLogLevel = (char)2;										/* 01/09/2001 */
   *(InitFile->expedite)   = '\0';
   
   while ( fgets(buffer, sizeof(buffer) - 1, fp) ) {
      buffer[strlen(buffer) - 1] = '\0';

      if ( strncmp(buffer, "logdir=", 7) == 0 ) {
         strcpy(InitFile->logdir, buffer + 7);
         CheckPath(InitFile->logdir);
      }
      else if ( strncmp(buffer, "qmgr=", 5) == 0 )
         strcpy(InitFile->qmgr, buffer + 5);
      else if ( strncmp(buffer, "replyq=", 7) == 0 )
         strcpy(InitFile->replyq, buffer + 7);
      else if ( strncmp(buffer, "replyqmgr=", 10) == 0 )								/* 22/05/2001 */
         strcpy(InitFile->replyqmgr, buffer + 10);										/* 22/05/2001 */
      else if ( strncmp(buffer, "expedite=", 9) == 0 )
         strcpy(InitFile->expedite, buffer + 9);
	   else if ( strncmp(buffer, "loglevel=", 9) == 0 ) {
         InitFile->loglevel = (char)atoi(buffer + 9);									/* 01/09/2001 */
			MQLogLevel = InitFile->loglevel;
	   }
   }

   MQLogLevel = InitFile->loglevel;
	
	if (fclose(fp) == EOF) {
     fprintf(stderr, "Cannot close profile : %s!\n", FileName);
     return(NULL);
	}

	return(InitFile);
}


int LogInitFile(PINITFILE InitFile, char *Title)
{
   int rc = 0;
   char LogText[255];

   sprintf(LogText,  "Start %s for QMgr %.48s" \
	                  "\n\t\t\treplyq    = %.48s" \
	                  "\n\t\t\treplyqmgr = %.48s" \
                     "\n\t\t\texpedite  = %s" \
					      "\n\t\t\tloglevel  = %d",
         Title,
		   ( (*(InitFile->qmgr) == '\0') ? "<default>" : InitFile->qmgr),
	      InitFile->replyq,
			( (*(InitFile->replyqmgr) == '\0') ? "<default>" : InitFile->replyqmgr),
         InitFile->expedite,
		   InitFile->loglevel );
      
   rc = WriteLogFile(InitFile->logdir, LOG_INFO, LogText);

   return(rc);
}
