/*@unused@*/ static char *sccsid = "xWMQexit.c  Version 1 Release 1, 10/12/2002";
/*                                                                    */
/* Version 1.0, 26/04/2000, First release NT                          */
/*              Compile options for Windows NT with MS C/C++ Compiler */
/*              cl /DNT /DDEBUG /LD xWMQexit.c                        */
/* Version 1.1, 10/12/2002, First release AIX                         */
/*                                                                    */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include <cmqc.h>
#include <cmqxc.h>

/* Platform specific include files */

#ifdef AIX
   #include <sys/types.h>
#endif

#ifdef NT
   #include <windows.h>
   #include <winbase.h>
#endif

#ifdef NT
   #define DllExport    __declspec( dllexport )
#else
   #define DllExport
#endif

/* Platform specific log files */

#ifdef NT
   #define LOG_TO_FILE "C:\\Program Files\\IBM\\MQSeries\\exits\\xWMQexit.txt"
#endif

#ifdef OS400
   #define LOG_TO_FILE "QMQM/MSGEXIT(XWMQEXIT)"
#endif

#ifdef AIX
   #define LOG_TO_FILE "/var/mqm/exits/xWMQexit.txt"
#endif

#ifdef DEBUG
	FILE *OST = NULL;
#endif

#ifdef OS400
#define DBGPRINTF(x) { \
         OST = fopen(LOG_TO_FILE, "a+, lrecl=239"); \
         if(OST) fprintf x; \
         fclose(OST); \
         }
#else
#define DBGPRINTF(x) { \
         OST = fopen(LOG_TO_FILE, "a+"); \
         if(OST) fprintf x; \
         fclose(OST); \
         }
#endif

#define  MAXTIMESIZE  22
char     TimeString[MAXTIMESIZE];

void MQStart(){;} /* dummy as described in manual */


char ExitData[MQ_EXIT_DATA_LENGTH];

#ifdef OS400
int main(int argc, char **argv)
{
   PMQCXP   pChannelExitParams = (PMQCXP)  argv[1];
   PMQCD    pChannelDefinition = (PMQCD)   argv[2];
   PMQLONG  pDataLength        = (PMQLONG) argv[3];
   PMQLONG  pAgentBufferLength = (PMQLONG) argv[4];
   PMQBYTE  AgentBuffer        = (PMQBYTE) argv[5];
   PMQLONG  pExitBufferLength  = (PMQLONG) argv[6];
   PMQPTR   pExitBufferAddr    = (PMQPTR)  argv[7];
#else
DllExport void MQENTRY xWMQexit(	PMQCXP   pChannelExitParams,
											PMQCD    pChannelDefinition,
											PMQLONG  pDataLength,
											PMQLONG  pAgentBufferLength,
											PMQBYTE  AgentBuffer,
											PMQLONG  pExitBufferLength,
											PMQPTR   pExitBufferAddr )
{
#endif

   static int i = 0;

	char *p = NULL;

#ifdef DEBUG
	struct tm   *time_now = NULL;
   time_t      secs_now;
   
	time(&secs_now);
   time_now = localtime(&secs_now);
   strftime(TimeString, MAXTIMESIZE, "%Y/%m/%d - %H:%M:%S", time_now);
#endif

	if ( strlen(pChannelExitParams->ExitData) ) 	{
		memset( ExitData, 0, (size_t)MQ_EXIT_DATA_LENGTH );
		strncpy( ExitData, pChannelExitParams->ExitData, (size_t)MQ_EXIT_DATA_LENGTH );
	   i = (int)MQ_EXIT_DATA_LENGTH;
      while ( ExitData[i] == ' ' &&  i > 0 ) ExitData[i] = '\0';
	} /* if ( strlen(pChannelExitParams->ExitData) ) */

   switch( pChannelExitParams-> ExitReason ) {
      case MQXR_INIT:
#ifdef DEBUG
         DBGPRINTF((OST,"%s Message channel exit called at MCA initialization\n", TimeString));
			DBGPRINTF((OST,"\t\t\tExitData %.*s\n",MQ_EXIT_DATA_LENGTH, ExitData));
#endif
         break;

      case MQXR_MSG:
#ifdef DEBUG
         DBGPRINTF((OST, "%s Processing a message, length = %li\n", TimeString, *pDataLength));
#endif
			/********************************************************************/
			/* MQSeries Services specific code begin                            */
         /*                                                                  */
#ifdef DEBUG
			DBGPRINTF((OST, "\t\t\tRemoteQMgrName %.*s\n", 48, ((PMQXQH)(AgentBuffer))->RemoteQMgrName));
			DBGPRINTF((OST, "\t\t\tReplyToQ       %.*s\n", 48, (PMQMD)((PMQXQH)(AgentBuffer))->MsgDesc.ReplyToQ));
#endif

			if ( strcmp("MQ31", ((PMQXQH)(AgentBuffer))->RemoteQMgrName) ) {
#ifdef DEBUG
				DBGPRINTF((OST, "%s RemoteQMgrName is MQ31\n", TimeString ));
#endif
				p = (char *)(PMQMD)((PMQXQH)(AgentBuffer))->MsgDesc.ReplyToQ;

				if ( *p == ' ' || *p == '\0'  ) {
#ifdef DEBUG
					DBGPRINTF((OST, "%s Empty MsgDesc.ReplyToQ\n", TimeString ));
#endif
					memcpy(p, ExitData, (size_t)MQ_EXIT_DATA_LENGTH);
            } /* if ( *p == ' ' || *p == '\0'  )                             */
         } /* if ( strcmp("MQ31", ((PMQXQH)(AgentBuffer))->RemoteQMgrName) ) */
         /*                                                                  */
			/* MQSeries Services specific code end                              */
			/********************************************************************/
         break;

      case MQXR_TERM:
#ifdef DEBUG
         DBGPRINTF((OST, "%s Message channel exit called at MCA termination\n",TimeString));
#endif
         break;

      default:
#ifdef DEBUG
         DBGPRINTF((OST, "Message channel exit called with invalid reason code: %d  %s\n",
                         pChannelExitParams-> ExitReason, TimeString));
#endif
         break;

   } /* switch( pChannelExitParams-> ExitReason ) */

   /* Set exit response = OK in all circumstances */

   pChannelExitParams -> ExitResponse = MQXCC_OK;

#ifdef OS400
   return 0;
#else
   return;
#endif
}
