#ifndef _H_DEFS
#define _H_DEFS

#include <limits.h>

#define BS         '\b'     /* backspace character  */
#define TAB        '\t'     /* tab character        */
#define CR         '\r'     /* carriage return char */
#define LF         '\n'     /* line feed character  */
#define FF         '\f'     /* form feed (^L) char  */
#define COMMA      ','      /* comma character      */
#define SPACE      ' '      /* space character      */
#define DOT        '.'      /* period/dot character */
#define BANG       '!'      /* exclaimation mark!   */
#define AT_SIGN    '@'      /* at-sign character    */
#define PERCENT    '%'      /* percent sign char.   */
#define COLON      ':'      /* the colon ..         */
#define BACKQUOTE  '`'      /* backquote character  */
#define TILDE      '~'      /* escape character~    */
#define ESCAPE     '\033'   /* the (ASCII) escape   */

#ifdef WIN32
   #define SEPARATOR '\\'
	#define PATH_MAX  512
#else
   #define SEPARATOR '/'
#endif

/* bool is a keyword in C++ */
/*@-cppnames@*/
typedef int bool;
/*@=cppnames@*/

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE (! FALSE)
#endif

#ifndef NO
#define NO     0
#define YES    1
#endif

#define EQUAL(s,w)		(strcmp((s),(w)) == 0)
#define EQUALM(s,w,x)	(memcmp((s),(w),(x)) == 0)
#define MIN(a,b)			( (a) < (b) ? (a) : (b) )
#define MAX(a,b)			( (a) > (b) ? (a) : (b) )
#define PLURAL(n)			n == 1 ? "" : "s"
#define LASTCH(s)			s[strlen(s)-1]

#define INITSTRARRAY(x)		memset((x), 0, (sizeof(x)));

#define  MAXLOGSIZE   102400

#define  LOGERRMSG    "ERROR --> see LOGERR file for details"

#define  MAXTIMESIZE  22

#define  _MQCONN      0
#define  _MQDISC      1
#define  _MQOPEN      2
#define  _MQCLOSE     3
#define  _MQGET       4
#define  _MQPUT       5
#define  _MQPUT1      6
#define  _MQINQ       7
#define  _MQSET       8
#define  _MQCMIT      9
#define  _MQBACK      10
#define  _MQBEGIN     11

#endif

