#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/* MQSeries product include file                                  */
#include <cmqc.h>
/* Utils include files                                            */
#include "defs.h"                     /* general include file     */
#include "file_util.h"                /* file functions           */
/* Functions specific include file                                */
#include "mq_util.h"
#ifdef OS400
#include <recio.h>
#endif

char *ReasonString(MQLONG reason)
{
  switch (reason) {
     PRINTREAS(MQRC_NONE)
     PRINTREAS(MQRC_ALIAS_BASE_Q_TYPE_ERROR)
     PRINTREAS(MQRC_ALREADY_CONNECTED)
     PRINTREAS(MQRC_BACKED_OUT)
     PRINTREAS(MQRC_BUFFER_ERROR)
     PRINTREAS(MQRC_BUFFER_LENGTH_ERROR)
     PRINTREAS(MQRC_CHAR_ATTR_LENGTH_ERROR)
     PRINTREAS(MQRC_CHAR_ATTRS_ERROR)
     PRINTREAS(MQRC_CHAR_ATTRS_TOO_SHORT)
     PRINTREAS(MQRC_CONNECTION_BROKEN)
     PRINTREAS(MQRC_DATA_LENGTH_ERROR)
     PRINTREAS(MQRC_DYNAMIC_Q_NAME_ERROR)
     PRINTREAS(MQRC_ENVIRONMENT_ERROR)
     PRINTREAS(MQRC_EXPIRY_ERROR)
     PRINTREAS(MQRC_FEEDBACK_ERROR)
     PRINTREAS(MQRC_GET_INHIBITED)
     PRINTREAS(MQRC_HANDLE_NOT_AVAILABLE)
     PRINTREAS(MQRC_HCONN_ERROR)
     PRINTREAS(MQRC_HOBJ_ERROR)
     PRINTREAS(MQRC_INHIBIT_VALUE_ERROR)
     PRINTREAS(MQRC_INT_ATTR_COUNT_ERROR)
     PRINTREAS(MQRC_INT_ATTR_COUNT_TOO_SMALL)
     PRINTREAS(MQRC_INT_ATTRS_ARRAY_ERROR)
     PRINTREAS(MQRC_SYNCPOINT_LIMIT_REACHED)
     PRINTREAS(MQRC_MAX_CONNS_LIMIT_REACHED)
     PRINTREAS(MQRC_MD_ERROR)
     PRINTREAS(MQRC_MISSING_REPLY_TO_Q)
     PRINTREAS(MQRC_MSG_TYPE_ERROR)
     PRINTREAS(MQRC_MSG_TOO_BIG_FOR_Q)
     PRINTREAS(MQRC_MSG_TOO_BIG_FOR_Q_MGR)
     PRINTREAS(MQRC_NO_MSG_AVAILABLE)
     PRINTREAS(MQRC_NO_MSG_UNDER_CURSOR)
     PRINTREAS(MQRC_NOT_AUTHORIZED)
     PRINTREAS(MQRC_NOT_OPEN_FOR_BROWSE)
     PRINTREAS(MQRC_NOT_OPEN_FOR_INPUT)
     PRINTREAS(MQRC_NOT_OPEN_FOR_INQUIRE)
     PRINTREAS(MQRC_NOT_OPEN_FOR_OUTPUT)
     PRINTREAS(MQRC_NOT_OPEN_FOR_SET)
     PRINTREAS(MQRC_OBJECT_CHANGED)
     PRINTREAS(MQRC_OBJECT_IN_USE)
     PRINTREAS(MQRC_OBJECT_TYPE_ERROR)
     PRINTREAS(MQRC_OD_ERROR)
     PRINTREAS(MQRC_OPTION_NOT_VALID_FOR_TYPE)
     PRINTREAS(MQRC_OPTIONS_ERROR)
     PRINTREAS(MQRC_PERSISTENCE_ERROR)
     PRINTREAS(MQRC_PERSISTENT_NOT_ALLOWED)
     PRINTREAS(MQRC_PRIORITY_EXCEEDS_MAXIMUM)
     PRINTREAS(MQRC_PRIORITY_ERROR)
     PRINTREAS(MQRC_PUT_INHIBITED)
     PRINTREAS(MQRC_Q_DELETED)
     PRINTREAS(MQRC_Q_FULL)
     PRINTREAS(MQRC_Q_NOT_EMPTY)
     PRINTREAS(MQRC_Q_SPACE_NOT_AVAILABLE)
	  PRINTREAS(MQRC_Q_TYPE_ERROR)
	  PRINTREAS(MQRC_Q_MGR_NAME_ERROR)
	  PRINTREAS(MQRC_Q_MGR_NOT_AVAILABLE)
     PRINTREAS(MQRC_REPORT_OPTIONS_ERROR)
     PRINTREAS(MQRC_SECOND_MARK_NOT_ALLOWED)
     PRINTREAS(MQRC_SECURITY_ERROR)
     PRINTREAS(MQRC_SELECTOR_COUNT_ERROR)
     PRINTREAS(MQRC_SELECTOR_LIMIT_EXCEEDED)
     PRINTREAS(MQRC_SELECTOR_ERROR)
     PRINTREAS(MQRC_SELECTOR_NOT_FOR_TYPE)
     PRINTREAS(MQRC_SIGNAL_OUTSTANDING)
     PRINTREAS(MQRC_SIGNAL_REQUEST_ACCEPTED)
     PRINTREAS(MQRC_STORAGE_NOT_AVAILABLE)
     PRINTREAS(MQRC_SYNCPOINT_NOT_AVAILABLE)
     PRINTREAS(MQRC_TRIGGER_CONTROL_ERROR)
     PRINTREAS(MQRC_TRIGGER_DEPTH_ERROR)
     PRINTREAS(MQRC_TRIGGER_MSG_PRIORITY_ERR)
     PRINTREAS(MQRC_TRIGGER_TYPE_ERROR)
     PRINTREAS(MQRC_TRUNCATED_MSG_ACCEPTED)
     PRINTREAS(MQRC_TRUNCATED_MSG_FAILED)
     PRINTREAS(MQRC_UNKNOWN_ALIAS_BASE_Q)
     PRINTREAS(MQRC_UNKNOWN_OBJECT_NAME)
     PRINTREAS(MQRC_UNKNOWN_OBJECT_Q_MGR)
     PRINTREAS(MQRC_UNKNOWN_REMOTE_Q_MGR)
     PRINTREAS(MQRC_WAIT_INTERVAL_ERROR)
     PRINTREAS(MQRC_XMIT_Q_TYPE_ERROR)
     PRINTREAS(MQRC_XMIT_Q_USAGE_ERROR)
     PRINTREAS(MQRC_NOT_OPEN_FOR_PASS_ALL)
     PRINTREAS(MQRC_NOT_OPEN_FOR_PASS_IDENT)
     PRINTREAS(MQRC_NOT_OPEN_FOR_SET_ALL)
     PRINTREAS(MQRC_NOT_OPEN_FOR_SET_IDENT)
     PRINTREAS(MQRC_CONTEXT_HANDLE_ERROR)
     PRINTREAS(MQRC_CONTEXT_NOT_AVAILABLE)
     PRINTREAS(MQRC_SIGNAL1_ERROR)
     PRINTREAS(MQRC_OBJECT_ALREADY_EXISTS)
     PRINTREAS(MQRC_OBJECT_DAMAGED)
     PRINTREAS(MQRC_RESOURCE_PROBLEM)
     PRINTREAS(MQRC_ANOTHER_Q_MGR_CONNECTED)
     PRINTREAS(MQRC_UNKNOWN_REPORT_OPTION)
     PRINTREAS(MQRC_STORAGE_CLASS_ERROR)
     PRINTREAS(MQRC_COD_NOT_VALID_FOR_XCF_Q)
     PRINTREAS(MQRC_XWAIT_CANCELED)
     PRINTREAS(MQRC_XWAIT_ERROR)
     PRINTREAS(MQRC_SUPPRESSED_BY_EXIT)
     PRINTREAS(MQRC_FORMAT_ERROR)
     PRINTREAS(MQRC_SOURCE_CCSID_ERROR)
     PRINTREAS(MQRC_SOURCE_INTEGER_ENC_ERROR)
     PRINTREAS(MQRC_SOURCE_DECIMAL_ENC_ERROR)
     PRINTREAS(MQRC_SOURCE_FLOAT_ENC_ERROR)
     PRINTREAS(MQRC_TARGET_CCSID_ERROR)
     PRINTREAS(MQRC_TARGET_INTEGER_ENC_ERROR)
     PRINTREAS(MQRC_TARGET_DECIMAL_ENC_ERROR)
     PRINTREAS(MQRC_TARGET_FLOAT_ENC_ERROR)
     PRINTREAS(MQRC_NOT_CONVERTED)
     PRINTREAS(MQRC_CONVERTED_MSG_TOO_BIG)
     /* PRINTREAS(MQRC_TRUNCATED) */
     PRINTREAS(MQRC_NO_EXTERNAL_PARTICIPANTS)
     PRINTREAS(MQRC_PARTICIPANT_NOT_AVAILABLE)
     PRINTREAS(MQRC_OUTCOME_MIXED)
     PRINTREAS(MQRC_OUTCOME_PENDING)
     PRINTREAS(MQRC_BRIDGE_STARTED)
     PRINTREAS(MQRC_BRIDGE_STOPPED)
     PRINTREAS(MQRC_ADAPTER_STORAGE_SHORTAGE)
     PRINTREAS(MQRC_UOW_IN_PROGRESS)
     PRINTREAS(MQRC_ADAPTER_CONN_LOAD_ERROR)
     PRINTREAS(MQRC_ADAPTER_SERV_LOAD_ERROR)
     PRINTREAS(MQRC_ADAPTER_DEFS_ERROR)
     PRINTREAS(MQRC_ADAPTER_DEFS_LOAD_ERROR)
     PRINTREAS(MQRC_ADAPTER_CONV_LOAD_ERROR)
     PRINTREAS(MQRC_BO_ERROR)
     PRINTREAS(MQRC_DH_ERROR)
     PRINTREAS(MQRC_MULTIPLE_REASONS)
     PRINTREAS(MQRC_OPEN_FAILED)
     PRINTREAS(MQRC_ADAPTER_DISC_LOAD_ERROR)
     PRINTREAS(MQRC_CNO_ERROR)
     PRINTREAS(MQRC_CICS_WAIT_FAILED)
     PRINTREAS(MQRC_DLH_ERROR)
     PRINTREAS(MQRC_HEADER_ERROR)
     PRINTREAS(MQRC_SOURCE_LENGTH_ERROR)
     PRINTREAS(MQRC_TARGET_LENGTH_ERROR)
     PRINTREAS(MQRC_SOURCE_BUFFER_ERROR)
     PRINTREAS(MQRC_TARGET_BUFFER_ERROR)
     PRINTREAS(MQRC_IIH_ERROR)
     PRINTREAS(MQRC_PCF_ERROR)
     PRINTREAS(MQRC_DBCS_ERROR)
     PRINTREAS(MQRC_OBJECT_NAME_ERROR)
     PRINTREAS(MQRC_OBJECT_Q_MGR_NAME_ERROR)
     PRINTREAS(MQRC_RECS_PRESENT_ERROR)
     PRINTREAS(MQRC_OBJECT_RECORDS_ERROR)
     PRINTREAS(MQRC_RESPONSE_RECORDS_ERROR)
     PRINTREAS(MQRC_ASID_MISMATCH)
     PRINTREAS(MQRC_PMO_RECORD_FLAGS_ERROR)
     PRINTREAS(MQRC_PUT_MSG_RECORDS_ERROR)
     PRINTREAS(MQRC_CONN_ID_IN_USE)
     PRINTREAS(MQRC_Q_MGR_QUIESCING)
     PRINTREAS(MQRC_Q_MGR_STOPPING)
     PRINTREAS(MQRC_DUPLICATE_RECOV_COORD)
     PRINTREAS(MQRC_PMO_ERROR)
     PRINTREAS(MQRC_API_EXIT_NOT_FOUND)
     PRINTREAS(MQRC_API_EXIT_LOAD_ERROR)
     PRINTREAS(MQRC_REMOTE_Q_NAME_ERROR)
     PRINTREAS(MQRC_INCONSISTENT_PERSISTENCE)
     PRINTREAS(MQRC_GMO_ERROR)
#ifndef V50
     PRINTREAS(MQRC_CICS_BRIDGE_RESTRICTION)
     PRINTREAS(MQRC_STOPPED_BY_CLUSTER_EXIT)
     PRINTREAS(MQRC_CLUSTER_RESOLUTION_ERROR)
     PRINTREAS(MQRC_CONVERTED_STRING_TOO_BIG)
#endif
     PRINTREAS(MQRC_TMC_ERROR)
     PRINTREAS(MQRC_PAGESET_FULL)
     PRINTREAS(MQRC_PAGESET_ERROR)
     PRINTREAS(MQRC_NAME_NOT_VALID_FOR_TYPE)
     PRINTREAS(MQRC_UNEXPECTED_ERROR)
     PRINTREAS(MQRC_UNKNOWN_XMIT_Q)
     PRINTREAS(MQRC_UNKNOWN_DEF_XMIT_Q)
     PRINTREAS(MQRC_DEF_XMIT_Q_TYPE_ERROR)
     PRINTREAS(MQRC_DEF_XMIT_Q_USAGE_ERROR)
     PRINTREAS(MQRC_NAME_IN_USE)
     PRINTREAS(MQRC_CONNECTION_QUIESCING)
     PRINTREAS(MQRC_CONNECTION_STOPPING)
     PRINTREAS(MQRC_ADAPTER_NOT_AVAILABLE)
     PRINTREAS(MQRC_MSG_ID_ERROR)
     PRINTREAS(MQRC_CORREL_ID_ERROR)
     PRINTREAS(MQRC_FILE_SYSTEM_ERROR)
     PRINTREAS(MQRC_NO_MSG_LOCKED)
     PRINTREAS(MQRC_FILE_NOT_AUDITED)
     PRINTREAS(MQRC_CONNECTION_NOT_AUTHORIZED)
     PRINTREAS(MQRC_MSG_TOO_BIG_FOR_CHANNEL)
     PRINTREAS(MQRC_CALL_IN_PROGRESS)
     PRINTREAS(MQRC_RMH_ERROR)
     PRINTREAS(MQRC_Q_MGR_ACTIVE)
     PRINTREAS(MQRC_Q_MGR_NOT_ACTIVE)
     PRINTREAS(MQRC_Q_DEPTH_HIGH)
     PRINTREAS(MQRC_Q_DEPTH_LOW)
     PRINTREAS(MQRC_Q_SERVICE_INTERVAL_HIGH)
     PRINTREAS(MQRC_Q_SERVICE_INTERVAL_OK)
#ifndef V50
     PRINTREAS(MQRC_UNIT_OF_WORK_NOT_STARTED)
#endif
     PRINTREAS(MQRC_CHANNEL_AUTO_DEF_OK)
     PRINTREAS(MQRC_CHANNEL_AUTO_DEF_ERROR)
     PRINTREAS(MQRC_CFH_ERROR)
     PRINTREAS(MQRC_CFIL_ERROR)
     PRINTREAS(MQRC_CFIN_ERROR)
     PRINTREAS(MQRC_CFSL_ERROR)
     PRINTREAS(MQRC_CFST_ERROR)
     PRINTREAS(MQRC_INCOMPLETE_GROUP)
     PRINTREAS(MQRC_INCOMPLETE_MSG)
     PRINTREAS(MQRC_INCONSISTENT_CCSIDS)
     PRINTREAS(MQRC_INCONSISTENT_ENCODINGS)
     PRINTREAS(MQRC_INCONSISTENT_UOW)
     PRINTREAS(MQRC_INVALID_MSG_UNDER_CURSOR)
     PRINTREAS(MQRC_MATCH_OPTIONS_ERROR)
     PRINTREAS(MQRC_MDE_ERROR)
     PRINTREAS(MQRC_MSG_FLAGS_ERROR)
     PRINTREAS(MQRC_MSG_SEQ_NUMBER_ERROR)
     PRINTREAS(MQRC_OFFSET_ERROR)
     PRINTREAS(MQRC_ORIGINAL_LENGTH_ERROR)
     PRINTREAS(MQRC_SEGMENT_LENGTH_ZERO)
     PRINTREAS(MQRC_UOW_NOT_AVAILABLE)
     PRINTREAS(MQRC_WRONG_GMO_VERSION)
     PRINTREAS(MQRC_WRONG_MD_VERSION)
     PRINTREAS(MQRC_GROUP_ID_ERROR)
     PRINTREAS(MQRC_INCONSISTENT_BROWSE)
     PRINTREAS(MQRC_XQH_ERROR)
     PRINTREAS(MQRC_SRC_ENV_ERROR)
     PRINTREAS(MQRC_SRC_NAME_ERROR)
     PRINTREAS(MQRC_DEST_ENV_ERROR)
     PRINTREAS(MQRC_DEST_NAME_ERROR)
     PRINTREAS(MQRC_TM_ERROR)
#ifndef V50
     PRINTREAS(MQRC_CLUSTER_EXIT_ERROR)
     PRINTREAS(MQRC_CLUSTER_EXIT_LOAD_ERROR)
     PRINTREAS(MQRC_CLUSTER_PUT_INHIBITED)
     PRINTREAS(MQRC_CLUSTER_RESOURCE_ERROR)
     PRINTREAS(MQRC_NO_DESTINATIONS_AVAILABLE)
     PRINTREAS(MQRC_CONNECTION_ERROR)
     PRINTREAS(MQRC_OPTION_ENVIRONMENT_ERROR)
     PRINTREAS(MQRC_CD_ERROR)
     PRINTREAS(MQRC_CLIENT_CONN_ERROR)
     PRINTREAS(MQRC_CHANNEL_STOPPED_BY_USER)
#endif
     PRINTREAS(MQRC_HCONFIG_ERROR)
     PRINTREAS(MQRC_FUNCTION_ERROR)
     PRINTREAS(MQRC_CHANNEL_STARTED)
     PRINTREAS(MQRC_CHANNEL_STOPPED)
     PRINTREAS(MQRC_CHANNEL_CONV_ERROR)
     PRINTREAS(MQRC_SERVICE_NOT_AVAILABLE)
     PRINTREAS(MQRC_INITIALIZATION_FAILED)
     PRINTREAS(MQRC_TERMINATION_FAILED)
     PRINTREAS(MQRC_UNKNOWN_Q_NAME)
     PRINTREAS(MQRC_SERVICE_ERROR)
     PRINTREAS(MQRC_Q_ALREADY_EXISTS)
     PRINTREAS(MQRC_USER_ID_NOT_AVAILABLE)
     PRINTREAS(MQRC_UNKNOWN_ENTITY)
     PRINTREAS(MQRC_UNKNOWN_AUTH_ENTITY)
     PRINTREAS(MQRC_UNKNOWN_REF_OBJECT)
     PRINTREAS(MQRC_CHANNEL_ACTIVATED)
     PRINTREAS(MQRC_CHANNEL_NOT_ACTIVATED)
#ifndef V50
     PRINTREAS(MQRC_UOW_CANCELED)
     PRINTREAS(MQRC_SELECTOR_TYPE_ERROR)
     PRINTREAS(MQRC_COMMAND_TYPE_ERROR)
     PRINTREAS(MQRC_MULTIPLE_INSTANCE_ERROR)
     PRINTREAS(MQRC_SYSTEM_ITEM_NOT_ALTERABLE)
     PRINTREAS(MQRC_BAG_CONVERSION_ERROR)
     PRINTREAS(MQRC_SELECTOR_OUT_OF_RANGE)
     PRINTREAS(MQRC_SELECTOR_NOT_UNIQUE)
     PRINTREAS(MQRC_INDEX_NOT_PRESENT)
     PRINTREAS(MQRC_STRING_ERROR)
     PRINTREAS(MQRC_ENCODING_NOT_SUPPORTED)
     PRINTREAS(MQRC_SELECTOR_NOT_PRESENT)
     PRINTREAS(MQRC_OUT_SELECTOR_ERROR)
     PRINTREAS(MQRC_STRING_TRUNCATED)
     PRINTREAS(MQRC_SELECTOR_WRONG_TYPE)
     PRINTREAS(MQRC_INCONSISTENT_ITEM_TYPE)
     PRINTREAS(MQRC_INDEX_ERROR)
     PRINTREAS(MQRC_SYSTEM_BAG_NOT_ALTERABLE)
     PRINTREAS(MQRC_ITEM_COUNT_ERROR)
     PRINTREAS(MQRC_FORMAT_NOT_SUPPORTED)
     PRINTREAS(MQRC_SELECTOR_NOT_SUPPORTED)
     PRINTREAS(MQRC_ITEM_VALUE_ERROR)
     PRINTREAS(MQRC_HBAG_ERROR)
     PRINTREAS(MQRC_PARAMETER_MISSING)
     PRINTREAS(MQRC_CMD_SERVER_NOT_AVAILABLE)
     PRINTREAS(MQRC_STRING_LENGTH_ERROR)
     PRINTREAS(MQRC_INQUIRY_COMMAND_ERROR)
     PRINTREAS(MQRC_NESTED_BAG_NOT_SUPPORTED)
     PRINTREAS(MQRC_BAG_WRONG_TYPE)
     PRINTREAS(MQRC_ITEM_TYPE_ERROR)
     PRINTREAS(MQRC_SYSTEM_BAG_NOT_DELETABLE)
     PRINTREAS(MQRC_SYSTEM_ITEM_NOT_DELETABLE)
     PRINTREAS(MQRC_CODED_CHAR_SET_ID_ERROR)
     PRINTREAS(MQRC_MSG_TOKEN_ERROR)
     PRINTREAS(MQRC_MISSING_WIH)
     PRINTREAS(MQRC_WIH_ERROR)
     PRINTREAS(MQRC_RFH_ERROR)
     PRINTREAS(MQRC_RFH_STRING_ERROR)
     PRINTREAS(MQRC_RFH_COMMAND_ERROR)
     PRINTREAS(MQRC_RFH_PARM_ERROR)
     PRINTREAS(MQRC_RFH_DUPLICATE_PARM)
     PRINTREAS(MQRC_RFH_PARM_MISSING)
#endif
     PRINTREAS(MQFB_CHANNEL_COMPLETED)
     PRINTREAS(MQFB_CHANNEL_FAIL_RETRY)
     PRINTREAS(MQFB_CHANNEL_FAIL)
     PRINTREAS(MQFB_APPL_CANNOT_BE_STARTED)
     PRINTREAS(MQFB_TM_ERROR)
     PRINTREAS(MQFB_APPL_TYPE_ERROR)
     PRINTREAS(MQFB_STOPPED_BY_MSG_EXIT)
     PRINTREAS(MQFB_XMIT_Q_MSG_ERROR)
     PRINTREAS(MQFB_SYSTEM_LAST)
     PRINTREAS(MQFB_APPL_FIRST)
     PRINTREAS(MQFB_APPL_LAST)
	 /* */
   default:
      return("UNKWOWN REASON");
      break;
  }
  return("UNKNOWN REASON");
}


#ifdef UTILV1
int WriteLogMQ(char *LogDir, int Verb, MQLONG CompCode, MQLONG Reason)
{
   char Text[256];
   char *MQI[] = {"MQCONN", "MQDISC", "MQOPEN", "MQCLOSE", "MQGET",
                  "MQPUT", "MQPUT1", "MQINQ", "MQSET", "MQCMIT", "MQBACK", "MQBEGIN" };
   int rc = 0;

	if (MQLogLevel < 0)																			/* 31/08/2001 */
		return 0;																					/* 31/08/2001 */

   switch (CompCode) {
      case MQCC_OK :
         if (MQLogLevel >= 3) {
            sprintf(Text, "%s ended OK", MQI[Verb]);
            rc = WriteLogFile(LogDir, LOG, Text);
         }
         break;
      case MQCC_WARNING :
         if (MQLogLevel >= 2) {
            sprintf(Text, "Warning : %s ended with reason code %ld : %s",
                                       MQI[Verb], Reason, ReasonString(Reason));
            rc = WriteLogFile(LogDir, LOG, Text);
         }
         break;
      case MQCC_FAILED :
         sprintf(Text, "ERROR : [%s] --> see LOGERR file for details",MQI[Verb]);
         (void)WriteLogFile(LogDir, LOG, Text);
			/* Return value (type int) ignored */
         sprintf(Text, "%s ended with reason code %ld : %s",
                                       MQI[Verb], Reason, ReasonString(Reason));
         rc = WriteLogFile(LogDir, LOGERR, Text);
         break;
      case MQCC_UNKNOWN :
         default :
            break;
   }
   return(rc);
}
#else
int WriteLogMQ(char *LogDir, int Verb, MQLONG CompCode, MQLONG Reason)
{
   char Text[256];
   char *MQI[] = {"MQCONN", "MQDISC", "MQOPEN", "MQCLOSE", "MQGET",
                  "MQPUT", "MQPUT1", "MQINQ", "MQSET", "MQCMIT", "MQBACK", "MQBEGIN" };
   int rc = 0;

	if (MQLogLevel < 0)
		return 0;

   switch (CompCode) {
      case MQCC_OK :
         if (MQLogLevel >= 3) {
            sprintf(Text, "%s ended OK", MQI[Verb]);
            rc = WriteLogFile(LogDir, LOG_INFO, Text);
         }
         break;
      case MQCC_WARNING :
         if (MQLogLevel >= 2) {
            sprintf(Text, "%s ended with reason code %ld : %s",
                                       MQI[Verb], Reason, ReasonString(Reason));
            rc = WriteLogFile(LogDir, LOG_WARNING, Text);
         }
         break;
      case MQCC_FAILED :
         sprintf(Text, "%s ended with reason code %ld : %s",
                                       MQI[Verb], Reason, ReasonString(Reason));
         rc = WriteLogFile(LogDir, LOG_ERROR, Text);
         break;
      case MQCC_UNKNOWN :
         default :
            break;
   }
   return(rc);
}
#endif


int GetMAXMSGL(char *LogDir, MQHCONN Hcon, MQCHAR48 QName, MQLONG *MAXMSGL)
{
   MQOD    odI = {MQOD_DEFAULT};       /* Object Descriptor for inquire        */
   MQMD     md = {MQMD_DEFAULT};       /* Message Descriptor                   */
   MQHOBJ   Hobj;                      /* object handle                        */
   MQLONG   O_options;                 /* MQOPEN options                       */
   MQLONG   C_options;                 /* MQCLOSE options                      */
   MQLONG   CompCode;                  /* completion code                      */
   MQLONG   Reason;                    /* reason code                          */
   MQLONG   Select[1];                 /* attribute selectors                  */
   MQLONG   IntAttrs[1];               /* array of integer attributes          */

   /*   Open the queue for inquire                                             */
   memcpy(odI.ObjectName, QName, (size_t)MQ_Q_NAME_LENGTH);
   O_options = MQOO_INQUIRE            /* open queue for inquire               */
             + MQOO_FAIL_IF_QUIESCING; /* but not if MQM stopping              */

   MQOPEN(Hcon,                        /* connection handle                    */
          &odI,                        /* object descriptor for queue          */
          O_options,                   /* open options                         */
          &Hobj,                       /* object handle                        */
          &CompCode,                   /* MQOPEN completion code               */
          &Reason);                    /* reason code								    */

	(void)WriteLogMQ(LogDir, _MQOPEN, CompCode, Reason);
	/* Return value (type int) ignored */

   if (CompCode == MQCC_FAILED)
     return((int)Reason);

   /*   Inquire the attributes of the queue                                    */
   Select[0] = MQIA_MAX_MSG_LENGTH;    /* attribute selectors                  */
   MQINQ(Hcon,                         /* connection handle                    */
         Hobj,                         /* object handle                        */
         1L,                           /* Selector count                       */
         Select,                       /* Selector array                       */
         1L,                           /* integer attribute count              */
         IntAttrs,                     /* integer attribute array              */
         0L,                           /* character attribute count            */
         NULL,                         /* character attribute array            */
         &CompCode,                    /* completion code                      */
         &Reason);                     /* reason code                          */

	(void)WriteLogMQ(LogDir, _MQINQ, CompCode, Reason);
	/* Return value (type int) ignored */

   if (CompCode == MQCC_FAILED)
     return((int)Reason);

   *MAXMSGL = IntAttrs[0];

   /*   Close queue after inquire                                              */
   C_options = 0;                      /* no close options                     */
   MQCLOSE(Hcon,                       /* connection handle                    */
           &Hobj,                      /* object handle                        */
           C_options,
           &CompCode,                  /* completion code                      */
           &Reason);                   /* reason code                          */

	(void)WriteLogMQ(LogDir, _MQCLOSE, CompCode, Reason);
	/* Return value (type int) ignored */

   return(0);
}


int GetQueueDepth(char *LogDir,MQHCONN Hcon, MQCHAR48 QName, MQLONG *Qdepth)
{
   MQOD    odI = {MQOD_DEFAULT};       /* Object Descriptor for inquire        */
   MQHOBJ   Hobj;                      /* object handle                        */
   MQLONG   O_options;                 /* MQOPEN options                       */
   MQLONG   CompCode;                  /* completion code                      */
   MQLONG   Reason;                    /* reason code                          */
   MQLONG   Select[1];                 /* attribute selectors                  */
   MQLONG   IntAttrs[1];               /* array of integer attributes          */

   /*   Open the queue for inquire                                             */
   memcpy(odI.ObjectName, QName, MQ_Q_NAME_LENGTH);
   O_options = MQOO_INQUIRE            /* open queue for inquire               */
             + MQOO_FAIL_IF_QUIESCING; /* but not if MQM stopping              */

   MQOPEN(Hcon,                        /* connection handle                    */
          &odI,                        /* object descriptor for queue          */
          O_options,                   /* open options                         */
          &Hobj,                       /* object handle                        */
          &CompCode,                   /* MQOPEN completion code               */
          &Reason);                    /* reason code                          */

   /* If it failed, report reason and stop                                     */
   (void)WriteLogMQ(LogDir, _MQOPEN, CompCode, Reason);
	/* Return value (type int) ignored */

   if (CompCode == MQCC_FAILED)
     return((int)Reason);

   /*   Inquire the attributes of the queue                                    */
   Select[0] = MQIA_CURRENT_Q_DEPTH;   /* attribute selectors                  */
   MQINQ(Hcon,                         /* connection handle                    */
         Hobj,                         /* object handle                        */
         1L,                           /* Selector count                       */
         Select,                       /* Selector array                       */
         1L,                           /* integer attribute count              */
         IntAttrs,                     /* integer attribute array              */
         0L,                           /* character attribute count            */
         NULL,                         /* character attribute array            */
         &CompCode,                    /* completion code                      */
         &Reason);                     /* reason code                          */

   *Qdepth = IntAttrs[0];

   (void)WriteLogMQ(LogDir, _MQINQ, CompCode, Reason);
	/* Return value (type int) ignored */

   MQCLOSE(Hcon, &Hobj, 0, &CompCode, &Reason);
   (void)WriteLogMQ(LogDir, _MQCLOSE, CompCode, Reason);
	/* Return value (type int) ignored */

   return(0);
}


int MQconn(char *LogDir, MQCHAR48 QMgrName, MQHCONN *Hconn)
{
   MQLONG   CompCode;                  /* completion code                      */
   MQLONG   Reason;                    /* reason code                          */

   MQCONN( QMgrName, Hconn, &CompCode, &Reason);
   (void)WriteLogMQ(LogDir, _MQCONN, CompCode, Reason);
	/* Return value (type int) ignored */

   if (CompCode == MQCC_FAILED) {
      printf("MQCONN FAILED\n%s", ReasonString(Reason));
      return((int)Reason);
   }

   return 0;
}


int MQdisc(char *LogDir, MQHCONN *Hconn)
{
   MQLONG   CompCode;                  /* completion code                      */
   MQLONG   Reason;                    /* reason code                          */

   MQDISC(Hconn, &CompCode, &Reason );
   (void)WriteLogMQ(LogDir, _MQDISC, CompCode, Reason);
	/* Return value (type int) ignored */

   return((int)Reason);
}


char *GetMQDate(char *pS, PMQMD pmdin)
{
   memset(pS, (int)':', MSGDATELEN);

   memcpy(pS,     pmdin->PutDate + 6, 2);
   memcpy(pS + 3, pmdin->PutDate + 4, 2);
   memcpy(pS + 6, pmdin->PutDate    , 4);

   return pS;
}


char *GetMQTime(char *pS, PMQMD pmdin)
{
   memset(pS, (int)':', MSGTIMELEN);

   memcpy(pS,     pmdin->PutTime    , 2);
   memcpy(pS + 3, pmdin->PutTime + 2, 2);
   memcpy(pS + 6, pmdin->PutTime + 4, 2);

   return pS;
}


#ifdef OS400
 /*********************************************************************/
 /*  MQBACK Function -- Back Out Changes                              */
 /*********************************************************************/

void MQENTRY MQBACK (
   MQHCONN  Hconn,      /* Connection handle */
   PMQLONG  pCompCode,  /* Completion code */
   PMQLONG  pReason)    /* Reason code qualifying CompCode */
{
	 _Rrollbck ( );
}

  /*********************************************************************/
 /*  MQCMIT Function -- Commit Changes                                */
 /*********************************************************************/

void MQENTRY MQCMIT (
   MQHCONN  Hconn,      /* Connection handle */
   PMQLONG  pCompCode,  /* Completion code */
   PMQLONG  pReason)    /* Reason code qualifying CompCode */
{
	_Rcommit ( "Transaction complete" );
}

#endif
